QCPCurve Class Reference
Author: Emanuel Eichhammer

· · · ·
Public Types | Public Functions | Protected Functions
QCPCurve Class Reference

A plottable representing a parametric curve in a plot. More...

Inheritance diagram for QCPCurve:

## Public Types
enum | LineStyle

## Public Functions
| QCPCurve (QCPAxis *keyAxis, QCPAxis *valueAxis)
QSharedPointer< QCPCurveDataContainer > | data () const
QCPScatterStyle | scatterStyle () const
int | scatterSkip () const
LineStyle | lineStyle () const
void | setData (QSharedPointer< QCPCurveDataContainer > data)
void | setData (const QVector< double > &t, const QVector< double > &keys, const QVector< double > &values, bool alreadySorted=false)
void | setData (const QVector< double > &keys, const QVector< double > &values)
void | setScatterStyle (const QCPScatterStyle &style)
void | setScatterSkip (int skip)
void | setLineStyle (LineStyle style)
void | addData (const QVector< double > &t, const QVector< double > &keys, const QVector< double > &values, bool alreadySorted=false)
void | addData (const QVector< double > &keys, const QVector< double > &values)
void | addData (double t, double key, double value)
void | addData (double key, double value)
virtual double | selectTest (const QPointF &pos, bool onlySelectable, QVariant *details=nullptr) const
virtual QCPRange | getKeyRange (bool &foundRange, QCP::SignDomain inSignDomain=QCP::sdBoth) const
virtual QCPRange | getValueRange (bool &foundRange, QCP::SignDomain inSignDomain=QCP::sdBoth, const QCPRange &inKeyRange=QCPRange()) const
Public Functions inherited from QCPAbstractPlottable1D< QCPCurveData >
| QCPAbstractPlottable1D (QCPAxis *keyAxis, QCPAxis *valueAxis)
virtual int | dataCount () const
virtual double | dataMainKey (int index) const
virtual double | dataSortKey (int index) const
virtual double | dataMainValue (int index) const
virtual QCPRange | dataValueRange (int index) const
virtual QPointF | dataPixelPosition (int index) const
virtual bool | sortKeyIsMainKey () const
virtual QCPDataSelection | selectTestRect (const QRectF &rect, bool onlySelectable) const
virtual int | findBegin (double sortKey, bool expandedRange=true) const
virtual int | findEnd (double sortKey, bool expandedRange=true) const
virtual QCPPlottableInterface1D * | interface1D ()
Public Functions inherited from QCPAbstractPlottable
| QCPAbstractPlottable (QCPAxis *keyAxis, QCPAxis *valueAxis)
QString | name () const
bool | antialiasedFill () const
bool | antialiasedScatters () const
QPen | pen () const
QBrush | brush () const
QCPAxis * | keyAxis () const
QCPAxis * | valueAxis () const
QCP::SelectionType | selectable () const
bool | selected () const
QCPDataSelection | selection () const
QCPSelectionDecorator * | selectionDecorator () const
void | setName (const QString &name)
void | setAntialiasedFill (bool enabled)
void | setAntialiasedScatters (bool enabled)
void | setPen (const QPen &pen)
void | setBrush (const QBrush &brush)
void | setKeyAxis (QCPAxis *axis)
void | setValueAxis (QCPAxis *axis)
Q_SLOT void | setSelectable (QCP::SelectionType selectable)
Q_SLOT void | setSelection (QCPDataSelection selection)
void | setSelectionDecorator (QCPSelectionDecorator *decorator)
void | coordsToPixels (double key, double value, double &x, double &y) const
const QPointF | coordsToPixels (double key, double value) const
void | pixelsToCoords (double x, double y, double &key, double &value) const
void | pixelsToCoords (const QPointF &pixelPos, double &key, double &value) const
void | rescaleAxes (bool onlyEnlarge=false) const
void | rescaleKeyAxis (bool onlyEnlarge=false) const
void | rescaleValueAxis (bool onlyEnlarge=false, bool inKeyRange=false) const
bool | addToLegend (QCPLegend *legend)
bool | addToLegend ()
bool | removeFromLegend (QCPLegend *legend) const
bool | removeFromLegend () const
Public Functions inherited from QCPLayerable
| QCPLayerable (QCustomPlot *plot, QString targetLayer=QString(), QCPLayerable *parentLayerable=nullptr)
bool | visible () const
QCustomPlot * | parentPlot () const
QCPLayerable * | parentLayerable () const
QCPLayer * | layer () const
bool | antialiased () const
void | setVisible (bool on)
Q_SLOT bool | setLayer (QCPLayer *layer)
bool | setLayer (const QString &layerName)
void | setAntialiased (bool enabled)
bool | realVisibility () const

## Protected Functions
virtual void | draw (QCPPainter *painter)
virtual void | drawLegendIcon (QCPPainter *painter, const QRectF &rect) const
virtual void | drawCurveLine (QCPPainter *painter, const QVector< QPointF > &lines) const
virtual void | drawScatterPlot (QCPPainter *painter, const QVector< QPointF > &points, const QCPScatterStyle &style) const
void | getCurveLines (QVector< QPointF > *lines, const QCPDataRange &dataRange, double penWidth) const
void | getScatters (QVector< QPointF > *scatters, const QCPDataRange &dataRange, double scatterWidth) const
int | getRegion (double key, double value, double keyMin, double valueMax, double keyMax, double valueMin) const
QPointF | getOptimizedPoint (int otherRegion, double otherKey, double otherValue, double key, double value, double keyMin, double valueMax, double keyMax, double valueMin) const
QVector< QPointF > | getOptimizedCornerPoints (int prevRegion, int currentRegion, double prevKey, double prevValue, double key, double value, double keyMin, double valueMax, double keyMax, double valueMin) const
bool | mayTraverse (int prevRegion, int currentRegion) const
bool | getTraverse (double prevKey, double prevValue, double key, double value, double keyMin, double valueMax, double keyMax, double valueMin, QPointF &crossA, QPointF &crossB) const
void | getTraverseCornerPoints (int prevRegion, int currentRegion, double keyMin, double valueMax, double keyMax, double valueMin, QVector< QPointF > &beforeTraverse, QVector< QPointF > &afterTraverse) const
double | pointDistance (const QPointF &pixelPoint, QCPCurveDataContainer::const_iterator &closestData) const
Protected Functions inherited from QCPAbstractPlottable1D< QCPCurveData >
void | getDataSegments (QList< QCPDataRange > &selectedSegments, QList< QCPDataRange > &unselectedSegments) const
void | drawPolyline (QCPPainter *painter, const QVector< QPointF > &lineData) const
Protected Functions inherited from QCPAbstractPlottable
virtual QRect | clipRect () const
virtual QCP::Interaction | selectionCategory () const
void | applyDefaultAntialiasingHint (QCPPainter *painter) const
virtual void | selectEvent (QMouseEvent *event, bool additive, const QVariant &details, bool *selectionStateChanged)
virtual void | deselectEvent (bool *selectionStateChanged)
void | applyFillAntialiasingHint (QCPPainter *painter) const
void | applyScattersAntialiasingHint (QCPPainter *painter) const
Protected Functions inherited from QCPLayerable
virtual void | parentPlotInitialized (QCustomPlot *parentPlot)
virtual void | mousePressEvent (QMouseEvent *event, const QVariant &details)
virtual void | mouseMoveEvent (QMouseEvent *event, const QPointF &startPos)
virtual void | mouseReleaseEvent (QMouseEvent *event, const QPointF &startPos)
virtual void | mouseDoubleClickEvent (QMouseEvent *event, const QVariant &details)
virtual void | wheelEvent (QWheelEvent *event)
void | initializeParentPlot (QCustomPlot *parentPlot)
void | setParentLayerable (QCPLayerable *parentLayerable)
bool | moveToLayer (QCPLayer *layer, bool prepend)
void | applyAntialiasingHint (QCPPainter *painter, bool localAntialiased, QCP::AntialiasedElement overrideElement) const

## Additional Inherited Members
Signals inherited from QCPAbstractPlottable
void | selectionChanged (bool selected)
void | selectionChanged (const QCPDataSelection &selection)
void | selectableChanged (QCP::SelectionType selectable)
Signals inherited from QCPLayerable
void | layerChanged (QCPLayer *newLayer)

## Detailed Description

A plottable representing a parametric curve in a plot.

Unlike QCPGraph, plottables of this type may have multiple points with the same key coordinate, so their visual representation can have loops. This is realized by introducing a third coordinate t, which defines the order of the points described by the other two coordinates x and y.

To plot data, assign it with the setData or addData functions. Alternatively, you can also access and modify the curve's data via the data method, which returns a pointer to the internal QCPCurveDataContainer.

Gaps in the curve can be created by adding data points with NaN as key and value (`qQNaN()` or `std::numeric_limits<double>::quiet_NaN()`) in between the two data points that shall be separated.

# Changing the appearance

The appearance of the curve is determined by the pen and the brush (setPen, setBrush).

# Usage

Like all data representing objects in QCustomPlot, the QCPCurve is a plottable (QCPAbstractPlottable). So the plottable-interface of QCustomPlot applies (QCustomPlot::plottable, QCustomPlot::removePlottable, etc.)

Usually, you first create an instance:

QCPCurve *newCurve = new QCPCurve(customPlot->xAxis, customPlot->yAxis);

which registers it with the QCustomPlot instance of the passed axes. Note that this QCustomPlot instance takes ownership of the plottable, so do not delete it manually but use QCustomPlot::removePlottable() instead. The newly created plottable can be modified, e.g.:

newCurve->setName("Fermat's Spiral");
newCurve->setData(tData, xData, yData);

## Member Enumeration Documentation

## § LineStyle

enum QCPCurve::LineStyle

Defines how the curve's line is represented visually in the plot. The line is drawn with the current pen of the curve (setPen).

See also
  setLineStyle

Enumerator
lsNone | No line is drawn between data points (e.g. only scatters)
lsLine | Data points are connected with a straight line.

## Constructor & Destructor Documentation

## § QCPCurve()

QCPCurve::QCPCurve | ( | QCPAxis * | keyAxis,
|  | QCPAxis * | valueAxis
| ) |  |
| explicit

Constructs a curve which uses keyAxis as its key axis ("x") and valueAxis as its value axis ("y"). keyAxis and valueAxis must reside in the same QCustomPlot instance and not have the same orientation. If either of these restrictions is violated, a corresponding message is printed to the debug output (qDebug), the construction is not aborted, though.

The created QCPCurve is automatically registered with the QCustomPlot instance inferred from keyAxis. This QCustomPlot instance takes ownership of the QCPCurve, so do not delete it manually but use QCustomPlot::removePlottable() instead.

## Member Function Documentation

## § data()

QSharedPointer< QCPCurveDataContainer > QCPCurve::data | ( |  | ) | const
| inline

Returns a shared pointer to the internal data storage of type QCPCurveDataContainer. You may use it to directly manipulate the data, which may be more convenient and faster than using the regular setData or addData methods.

## § setData() [1/3]

void QCPCurve::setData | ( | QSharedPointer< QCPCurveDataContainer > | data | ) |

This is an overloaded function.

Replaces the current data container with the provided data container.

Since a QSharedPointer is used, multiple QCPCurves may share the same data container safely. Modifying the data in the container will then affect all curves that share the container. Sharing can be achieved by simply exchanging the data containers wrapped in shared pointers:

curve2->setData(curve1->data()); // curve1 and curve2 now share data container

If you do not wish to share containers, but create a copy from an existing container, rather use the QCPDataContainer<DataType>::set method on the curve's data container directly:

curve2->data()->set(*curve1->data()); // curve2 now has copy of curve1's data in its container

See also
  addData

## § setData() [2/3]

void QCPCurve::setData | ( | const QVector< double > & | t,
|  | const QVector< double > & | keys,
|  | const QVector< double > & | values,
|  | bool | alreadySorted = `false`
| ) |  |

This is an overloaded function.

Replaces the current data with the provided points in t, keys and values. The provided vectors should have equal length. Else, the number of added points will be the size of the smallest vector.

If you can guarantee that the passed data points are sorted by t in ascending order, you can set alreadySorted to true, to improve performance by saving a sorting run.

See also
  addData

## § setData() [3/3]

void QCPCurve::setData | ( | const QVector< double > & | keys,
|  | const QVector< double > & | values
| ) |  |

This is an overloaded function.

Replaces the current data with the provided points in keys and values. The provided vectors should have equal length. Else, the number of added points will be the size of the smallest vector.

The t parameter of each data point will be set to the integer index of the respective key/value pair.

See also
  addData

## § setScatterStyle()

void QCPCurve::setScatterStyle | ( | const QCPScatterStyle & | style | ) |

Sets the visual appearance of single data points in the plot. If set to QCPScatterStyle::ssNone, no scatter points are drawn (e.g. for line-only plots with appropriate line style).

See also
  QCPScatterStyle, setLineStyle

## § setScatterSkip()

void QCPCurve::setScatterSkip | ( | int | skip | ) |

If scatters are displayed (scatter style not QCPScatterStyle::ssNone), skip number of scatter points are skipped/not drawn after every drawn scatter point.

This can be used to make the data appear sparser while for example still having a smooth line, and to improve performance for very high density plots.

If skip is set to 0 (default), all scatter points are drawn.

See also
  setScatterStyle

## § setLineStyle()

void QCPCurve::setLineStyle | ( | QCPCurve::LineStyle | style | ) |

Sets how the single data points are connected in the plot or how they are represented visually apart from the scatter symbol. For scatter-only plots, set style to lsNone and setScatterStyle to the desired scatter style.

See also
  setScatterStyle

## § addData() [1/4]

void QCPCurve::addData | ( | const QVector< double > & | t,
|  | const QVector< double > & | keys,
|  | const QVector< double > & | values,
|  | bool | alreadySorted = `false`
| ) |  |

This is an overloaded function.

Adds the provided points in t, keys and values to the current data. The provided vectors should have equal length. Else, the number of added points will be the size of the smallest vector.

If you can guarantee that the passed data points are sorted by keys in ascending order, you can set alreadySorted to true, to improve performance by saving a sorting run.

Alternatively, you can also access and modify the data directly via the data method, which returns a pointer to the internal data container.

## § addData() [2/4]

void QCPCurve::addData | ( | const QVector< double > & | keys,
|  | const QVector< double > & | values
| ) |  |

This is an overloaded function.

Adds the provided points in keys and values to the current data. The provided vectors should have equal length. Else, the number of added points will be the size of the smallest vector.

The t parameter of each data point will be set to the integer index of the respective key/value pair.

Alternatively, you can also access and modify the data directly via the data method, which returns a pointer to the internal data container.

## § addData() [3/4]

void QCPCurve::addData | ( | double | t,
|  | double | key,
|  | double | value
| ) |  |

This is an overloaded function. Adds the provided data point as t, key and value to the current data.

Alternatively, you can also access and modify the data directly via the data method, which returns a pointer to the internal data container.

## § addData() [4/4]

void QCPCurve::addData | ( | double | key,
|  | double | value
| ) |  |

This is an overloaded function.

Adds the provided data point as key and value to the current data.

The t parameter is generated automatically by increments of 1 for each point, starting at the highest t of previously existing data or 0, if the curve data is empty.

Alternatively, you can also access and modify the data directly via the data method, which returns a pointer to the internal data container.

## § selectTest()

double QCPCurve::selectTest | ( | const QPointF & | pos,
|  | bool | onlySelectable,
|  | QVariant * | details = `nullptr`
| ) |  | const
| virtual

Implements a selectTest specific to this plottable's point geometry.

If details is not 0, it will be set to a QCPDataSelection, describing the closest data point to pos.

For general information about this virtual method, see the base class implementation. QCPAbstractPlottable::selectTest

Reimplemented from QCPAbstractPlottable1D< QCPCurveData >.

## § getKeyRange()

QCPRange QCPCurve::getKeyRange | ( | bool & | foundRange,
|  | QCP::SignDomain | inSignDomain = `QCP::sdBoth`
| ) |  | const
| virtual

Returns the coordinate range that all data in this plottable span in the key axis dimension. For logarithmic plots, one can set inSignDomain to either QCP::sdNegative or QCP::sdPositive in order to restrict the returned range to that sign domain. E.g. when only negative range is wanted, set inSignDomain to QCP::sdNegative and all positive points will be ignored for range calculation. For no restriction, just set inSignDomain to QCP::sdBoth (default). foundRange is an output parameter that indicates whether a range could be found or not. If this is false, you shouldn't use the returned range (e.g. no points in data).

Note that foundRange is not the same as QCPRange::validRange, since the range returned by this function may have size zero (e.g. when there is only one data point). In this case foundRange would return true, but the returned range is not a valid range in terms of QCPRange::validRange.

See also
  rescaleAxes, getValueRange

Implements QCPAbstractPlottable.

## § getValueRange()

QCPRange QCPCurve::getValueRange | ( | bool & | foundRange,
|  | QCP::SignDomain | inSignDomain = `QCP::sdBoth`,
|  | const QCPRange & | inKeyRange = `QCPRange()`
| ) |  | const
| virtual

Returns the coordinate range that the data points in the specified key range (inKeyRange) span in the value axis dimension. For logarithmic plots, one can set inSignDomain to either QCP::sdNegative or QCP::sdPositive in order to restrict the returned range to that sign domain. E.g. when only negative range is wanted, set inSignDomain to QCP::sdNegative and all positive points will be ignored for range calculation. For no restriction, just set inSignDomain to QCP::sdBoth (default). foundRange is an output parameter that indicates whether a range could be found or not. If this is false, you shouldn't use the returned range (e.g. no points in data).

If inKeyRange has both lower and upper bound set to zero (is equal to `QCPRange()`), all data points are considered, without any restriction on the keys.

Note that foundRange is not the same as QCPRange::validRange, since the range returned by this function may have size zero (e.g. when there is only one data point). In this case foundRange would return true, but the returned range is not a valid range in terms of QCPRange::validRange.

See also
  rescaleAxes, getKeyRange

Implements QCPAbstractPlottable.

## § draw()

void QCPCurve::draw | ( | QCPPainter * | painter | ) |
| protectedvirtual

This function draws the layerable with the specified painter. It is only called by QCustomPlot, if the layerable is visible (setVisible).

Before this function is called, the painter's antialiasing state is set via applyDefaultAntialiasingHint, see the documentation there. Further, the clipping rectangle was set to clipRect.

Implements QCPAbstractPlottable.

## § drawLegendIcon()

void QCPCurve::drawLegendIcon | ( | QCPPainter * | painter,
|  | const QRectF & | rect
| ) |  | const
| protectedvirtual

called by QCPLegend::draw (via QCPPlottableLegendItem::draw) to create a graphical representation of this plottable inside rect, next to the plottable name.

The passed painter has its cliprect set to rect, so painting outside of rect won't appear outside the legend icon border.

Implements QCPAbstractPlottable.

## § drawCurveLine()

void QCPCurve::drawCurveLine | ( | QCPPainter * | painter,
|  | const QVector< QPointF > & | lines
| ) |  | const
| protectedvirtual

Draws lines between the points in lines, given in pixel coordinates.

See also
  drawScatterPlot, getCurveLines

## § drawScatterPlot()

void QCPCurve::drawScatterPlot | ( | QCPPainter * | painter,
|  | const QVector< QPointF > & | points,
|  | const QCPScatterStyle & | style
| ) |  | const
| protectedvirtual

Draws scatter symbols at every point passed in points, given in pixel coordinates. The scatters will be drawn with painter and have the appearance as specified in style.

See also
  drawCurveLine, getCurveLines

## § getCurveLines()

void QCPCurve::getCurveLines | ( | QVector< QPointF > * | lines,
|  | const QCPDataRange & | dataRange,
|  | double | penWidth
| ) |  | const
| protected

Called by draw to generate points in pixel coordinates which represent the line of the curve.

Line segments that aren't visible in the current axis rect are handled in an optimized way. They are projected onto a rectangle slightly larger than the visible axis rect and simplified regarding point count. The algorithm makes sure to preserve appearance of lines and fills inside the visible axis rect by generating new temporary points on the outer rect if necessary.

lines will be filled with points in pixel coordinates, that can be drawn with drawCurveLine.

dataRange specifies the beginning and ending data indices that will be taken into account for conversion. In this function, the specified range may exceed the total data bounds without harm: a correspondingly trimmed data range will be used. This takes the burden off the user of this function to check for valid indices in dataRange, e.g. when extending ranges coming from getDataSegments.

penWidth specifies the pen width that will be used to later draw the lines generated by this function. This is needed here to calculate an accordingly wider margin around the axis rect when performing the line optimization.

Methods that are also involved in the algorithm are: getRegion, getOptimizedPoint, getOptimizedCornerPoints mayTraverse, getTraverse, getTraverseCornerPoints.

See also
  drawCurveLine, drawScatterPlot

## § getScatters()

void QCPCurve::getScatters | ( | QVector< QPointF > * | scatters,
|  | const QCPDataRange & | dataRange,
|  | double | scatterWidth
| ) |  | const
| protected

Called by draw to generate points in pixel coordinates which represent the scatters of the curve. If a scatter skip is configured (setScatterSkip), the returned points are accordingly sparser.

Scatters that aren't visible in the current axis rect are optimized away.

scatters will be filled with points in pixel coordinates, that can be drawn with drawScatterPlot.

dataRange specifies the beginning and ending data indices that will be taken into account for conversion.

scatterWidth specifies the scatter width that will be used to later draw the scatters at pixel coordinates generated by this function. This is needed here to calculate an accordingly wider margin around the axis rect when performing the data point reduction.

See also
  draw, drawScatterPlot

## § getRegion()

int QCPCurve::getRegion | ( | double | key,
|  | double | value,
|  | double | keyMin,
|  | double | valueMax,
|  | double | keyMax,
|  | double | valueMin
| ) |  | const
| protected

This function is part of the curve optimization algorithm of getCurveLines.

It returns the region of the given point (key, value) with respect to a rectangle defined by keyMin, keyMax, valueMin, and valueMax.

The regions are enumerated from top to bottom (valueMin to valueMax) and left to right (keyMin to keyMax):

1 | 4 | 7
2 | 5 | 8
3 | 6 | 9

With the rectangle being region 5, and the outer regions extending infinitely outwards. In the curve optimization algorithm, region 5 is considered to be the visible portion of the plot.

## § getOptimizedPoint()

QPointF QCPCurve::getOptimizedPoint | ( | int | otherRegion,
|  | double | otherKey,
|  | double | otherValue,
|  | double | key,
|  | double | value,
|  | double | keyMin,
|  | double | valueMax,
|  | double | keyMax,
|  | double | valueMin
| ) |  | const
| protected

This function is part of the curve optimization algorithm of getCurveLines.

This method is used in case the current segment passes from inside the visible rect (region 5, see getRegion) to any of the outer regions (otherRegion). The current segment is given by the line connecting (key, value) with (otherKey, otherValue).

It returns the intersection point of the segment with the border of region 5.

For this function it doesn't matter whether (key, value) is the point inside region 5 or whether it's (otherKey, otherValue), i.e. whether the segment is coming from region 5 or leaving it. It is important though that otherRegion correctly identifies the other region not equal to 5.

## § getOptimizedCornerPoints()

QVector< QPointF > QCPCurve::getOptimizedCornerPoints | ( | int | prevRegion,
|  | int | currentRegion,
|  | double | prevKey,
|  | double | prevValue,
|  | double | key,
|  | double | value,
|  | double | keyMin,
|  | double | valueMax,
|  | double | keyMax,
|  | double | valueMin
| ) |  | const
| protected

This function is part of the curve optimization algorithm of getCurveLines.

In situations where a single segment skips over multiple regions it might become necessary to add extra points at the corners of region 5 (see getRegion) such that the optimized segment doesn't unintentionally cut through the visible area of the axis rect and create plot artifacts. This method provides these points that must be added, assuming the original segment doesn't start, end, or traverse region 5. (Corner points where region 5 is traversed are calculated by getTraverseCornerPoints.)

For example, consider a segment which directly goes from region 4 to 2 but originally is far out to the top left such that it doesn't cross region 5. Naively optimizing these points by projecting them on the top and left borders of region 5 will create a segment that surely crosses 5, creating a visual artifact in the plot. This method prevents this by providing extra points at the top left corner, making the optimized curve correctly pass from region 4 to 1 to 2 without traversing 5.

## § mayTraverse()

bool QCPCurve::mayTraverse | ( | int | prevRegion,
|  | int | currentRegion
| ) |  | const
| protected

This function is part of the curve optimization algorithm of getCurveLines.

This method returns whether a segment going from prevRegion to currentRegion (see getRegion) may traverse the visible region 5. This function assumes that neither prevRegion nor currentRegion is 5 itself.

If this method returns false, the segment for sure doesn't pass region 5. If it returns true, the segment may or may not pass region 5 and a more fine-grained calculation must be used (getTraverse).

## § getTraverse()

bool QCPCurve::getTraverse | ( | double | prevKey,
|  | double | prevValue,
|  | double | key,
|  | double | value,
|  | double | keyMin,
|  | double | valueMax,
|  | double | keyMax,
|  | double | valueMin,
|  | QPointF & | crossA,
|  | QPointF & | crossB
| ) |  | const
| protected

This function is part of the curve optimization algorithm of getCurveLines.

This method assumes that the mayTraverse test has returned true, so there is a chance the segment defined by (prevKey, prevValue) and (key, value) goes through the visible region 5.

The return value of this method indicates whether the segment actually traverses region 5 or not.

If the segment traverses 5, the output parameters crossA and crossB indicate the entry and exit points of region 5. They will become the optimized points for that segment.

## § getTraverseCornerPoints()

void QCPCurve::getTraverseCornerPoints | ( | int | prevRegion,
|  | int | currentRegion,
|  | double | keyMin,
|  | double | valueMax,
|  | double | keyMax,
|  | double | valueMin,
|  | QVector< QPointF > & | beforeTraverse,
|  | QVector< QPointF > & | afterTraverse
| ) |  | const
| protected

This function is part of the curve optimization algorithm of getCurveLines.

This method assumes that the getTraverse test has returned true, so the segment definitely traverses the visible region 5 when going from prevRegion to currentRegion.

In certain situations it is not sufficient to merely generate the entry and exit points of the segment into/out of region 5, as getTraverse provides. It may happen that a single segment, in addition to traversing region 5, skips another region outside of region 5, which makes it necessary to add an optimized corner point there (very similar to the job getOptimizedCornerPoints does for segments that are completely in outside regions and don't traverse 5).

As an example, consider a segment going from region 1 to region 6, traversing the lower left corner of region 5. In this configuration, the segment additionally crosses the border between region 1 and 2 before entering region 5. This makes it necessary to add an additional point in the top left corner, before adding the optimized traverse points. So in this case, the output parameter beforeTraverse will contain the top left corner point, and afterTraverse will be empty.

In some cases, such as when going from region 1 to 9, it may even be necessary to add additional corner points before and after the traverse. Then both beforeTraverse and afterTraverse return the respective corner points.

## § pointDistance()

double QCPCurve::pointDistance | ( | const QPointF & | pixelPoint,
|  | QCPCurveDataContainer::const_iterator & | closestData
| ) |  | const
| protected

Calculates the (minimum) distance (in pixels) the curve's representation has from the given pixelPoint in pixels. This is used to determine whether the curve was clicked or not, e.g. in selectTest. The closest data point to pixelPoint is returned in closestData. Note that if the curve has a line representation, the returned distance may be smaller than the distance to the closestData point, since the distance to the curve line is also taken into account.

If either the curve has no data or if the line style is lsNone and the scatter style's shape is QCPScatterStyle::ssNone (i.e. there is no visual representation of the curve), returns -1.0.

The documentation for this class was generated from the following files:

- src/plottables/plottable-curve.h
- src/plottables/plottable-curve.cpp